# A program for making an optimal team based on a 
# qualifier round (or rounds).
# By Avram Lyon (quizbowl@gimranov.com)

pick <- function(max) {
    combs <- c();
    for (i in 1:(max-3)) {
	for (j in (i+1):(max-2)) {
	    for (k in (j+1):(max-1)) {
		for (l in (k+1):max) {
		    combs <- c(combs,i,j,k,l);
		}
	    }
	}
    }
    dim(combs) <- c(4,length(combs)/4);
    return(combs);
}

pick3 <- function(max) {
    combs <- c();
    for (j in 1:(max-2)) {
        for (k in (j+1):(max-1)) {
            for (l in (k+1):max) {
                combs <- c(combs,j,k,l);
            }
        }
    }
    dim(combs) <- c(3,length(combs)/3);
    return(combs);
}

buzzer <- function(k) {
    if(sum(k==15)>0) {return(15)}
    if(sum(k==-5)>0) {return(-5)}
    if(sum(k==10)>0) {return(10)}
    return(0);
}

score <- function(tups, bons) {
    combs <- pick(dim(tups)[1]);
    # If for some reason you are forming 3-person teams, uncomment the
    # following line.
    #combs <- pick3(dim(tups)[1]);
    bonvals <- bons[1,];
    bons <- bons[-1,];

    tmscore <- numeric(dim(combs)[2]);
    bonconv <- numeric(dim(combs)[2]);
    tuppts <- numeric(dim(combs)[2]);

    for (i in 1:dim(combs)[2]) {
	tupres <- apply(tups[combs[,i],],2,buzzer);
	tupscore <- sum(tupres);
	tupct <- sum(tupres>0);

	bonres<- apply(bons[combs[,i],],2,max);
	bonconv[i] <- sum(bonres)*30/sum(bonvals);
	tmscore[i] <- tupscore + bonconv[i]*tupct;
        tuppts[i] <- tupscore;
    }
    res <- data.frame(t(combs),tmscore,bonconv,tuppts);
    res <- res[order(res$tmscore),];
    return(res);
}

# This sets the files contain the tossup and bonus data. Change the filename
# as appropriate.
tups <- read.table("Tossups.qb");
bonuses <- read.table("Bonuses.qb");

# If you have each player's scores in a separate column, delete the pound
# signs at the beginning of the next two lines.
#bonuses <- t(bonuses)      # Transpose, because we did them the wrong way.
#tups <- t(tups)

scores <- score(tups,bonuses);
scores<- scores[order(scores$tmscore,decreasing=T),];
write.table(scores, "Ranking.qb",sep="\t",col.names=T,row.names=F);
